' ---------------------------------------------------------------------------------------
'    Rollercontrol
' ---------------------------------------------------------------------------------------
'    Version 6.5, 17.05.2016, Copyright 2016, Kai Sattler und Harald Sattler
' ---------------------------------------------------------------------------------------
'
'    Dieses Programm ist Freie Software: Sie knnen es unter den Bedingungen
'    der GNU General Public License, wie von der Free Software Foundation,
'    Version 3 der Lizenz oder (nach Ihrer Wahl) jeder neueren
'    verffentlichten Version, weiterverbreiten und/oder modifizieren.
'
'    Dieses Programm wird in der Hoffnung, dass es ntzlich sein wird, aber
'    OHNE JEDE GEWHRLEISTUNG, bereitgestellt; sogar ohne die implizite
'    Gewhrleistung der MARKTFHIGKEIT oder EIGNUNG FR EINEN BESTIMMTEN ZWECK.
'    Siehe die GNU General Public License fr weitere Details.
'
'    Sie sollten eine Kopie der GNU General Public License zusammen mit diesem
'    Programm erhalten haben. Wenn nicht, siehe <http://www.gnu.org/licenses/>.
' ---------------------------------------------------------------------------------------
'
'
' Programmer fr Mega8: mySmartUSB light auf Com3, STK500 native driver
'
' Hardware PWM mit Timer1
' Fuses beim ERSTEN flashen eines NEUEN Controllers einmalig einkommentieren, dann wieder auskommentieren
'   $prog &HFF , &H04 , &HC1 , &H00                             ' generated. Take care that the chip supports all fuse bytes.

' ber den Analogeingang PortC.4 wird ein Poti (oder ein Daumengashebel mit Hallsensor) eingelesen
' Der Analogwert setzt direkt das PWM-Signal
' Es wird in diesem Modus KEIN PPM-Signal fr einen Standard-ESC erzeugt, sondern ein PWM-Signal
' Der ESC MUSS UNBEDINGT die SimonK Firmware haben, die erkennt automatisch beim Einschalten,
' ob PPM (1..2 ms) oder PWM (0..100%) anliegt.
'
' Achtung!
' --->> Ab Version V5 steuert der Controller einen Standard-ESC mit PPM an <<---
' Der ESC (YGE 100A oder so) untersttzt Bremsen
' Das PPM-Ausgangssignal geht von 1500 s bis 2000 s fr Beschleunigen
' Ist das PPM-Signal unterhalb von 1500 s bremst der ESC
' Die Bremstaste wird abgefragt. Der Gashebel wird beim Bremsen ignoriert, der ESC bremst subjektiv immer gleich stark
'
' Seit V3 (oder V4?) wird die komplette Schaltung ber ein Relais stromlos geschaltet, wenn das Gas lnger als 3 Minuten nicht bedient wurde
'  -> Sicherheitsabschaltung um den Akku vor Tiefentladung zu schtzen
'
' V6: StVO-Modus
' Wenn beim Einschalten am Schiebeschalter die Bremstaste NICHT gedrckt wird, wird die Hchstgeschwindigkeit auf 12 km/h begrenzt
' Um Vmax zu erreichen, muss beim Einschalten die Bremstaste festgehalten werden.
' Die Bremse ist digital (ein/aus), nicht mehr proportional (kann der ESC sowieso nicht)
'
' V6.5: Bremse wird aktiv gelst, durch kurzes "Gasgeben" nachdem Bremstaste gelst wurde
'
' Mgliche Erweiterungen:
' Akkuspannungsberwachung und/oder -Anzeige ber LEDs (Grn, Gelb, Rot)
' Konfiguration von Parametern ber LCD-Config (serielle Schnittstelle)
' Konfiguration von Parametern ber Bluetooth/Smartphone ;-)
'

$regfile = "m8def.dat"
$framesize = 16
$swstack = 16
$hwstack = 32
$crystal = 8000000

' Alias
In_daumengas Alias Pinc.0                                   ' Gashebel
In_bremstaste Alias Pinc.1                                  ' Bremstaste
Blinkerled Alias Portb.6                                    ' Lebenszeichen
Relcon Alias Portd.2                                        ' Ausgang fr Cutoff-Relais
Led_red Alias Portd.3
Drivemode Alias Pind.5                                      ' Auswahl der Gaskurve(n)
Beeper Alias Portc.2                                        ' Ausgang Piepser

Config Portb.1 = Output                                     ' Ausgang des PPM-/PWM-Signals zum ESC
Config Portb.2 = Output                                     ' Ausgang fr Brems-FETs
Config Relcon = Output                                      ' Ausgang fr Cutoff-Relais

Config Led_red = Output                                     ' Messausgang fr Schleifenfrequenz
Config Blinkerled = Output                                  ' Lebenszeichen
Config In_daumengas = Input                                 ' Eingang fr Daumen-Gas
Config In_bremstaste = Input                                ' Eingang fr Brems-Taste
In_bremstaste = 1                                           ' Internal PullUp einschalten
Config Drivemode = Input                                    ' Eingang fr Gaskurven-Taste
Drivemode = 1                                               ' Internal PullUp einschalten

'Config Timer1 = Pwm , Pwm = 10 , Compare A Pwm = Clear Up , Compare B Pwm = Clear Up , Prescale = 1
Config Timer1 = Timer , Prescale = 1 , Compare A = Disconnect , Compare B = Disconnect       'aus "ppm_generator_test.bas"
On Timer1 Esc_irq
Config Timer0 = Timer , Prescale = 1024                     ' Timer fr Timeout
On Timer0 On_timer0_overflow                                ' 7812 incr ist ca 1 sek

Declare Sub Cutoff

'The prescaler divides the internal clock by 2,4,8,16,32,64 or 128
'Because the ADC needs a clock from 50-200 KHz
'The AUTO feature, will select the highest clockrate possible
Config Adc = Single , Prescaler = Auto , Reference = Avcc

' Watchdog
Config Watchdog = 512

' Variablen
Dim Timer0counter As Word , Timer0sekunde As Byte , Hebelbewegt As Bit
Dim W As Word , L As Single , Gas As Integer , Postbraketmr As Integer , Postthrtmr As Byte
Dim Channel As Byte , Flagmax As Byte , Brakebutton As Byte
Dim Difflw As Integer , Loopcount As Word , Difflwbrake As Integer       ' Diff wird beim Abbremsen negativ
Dim Incrstepthr As Word , Daumengas As Word , Pwmoutbrake As Word , Incrstepbrake As Word
Dim Pwmoutthr As Word , Pwmstep As Word , Lastpwmoutthr As Word , Lastpwmoutbrake As Word
Dim Scalethr As Single , Indiff As Single , Outdiff As Single
Dim Inmin As Word , Inmax As Word , Inmintemp As Word
Dim Outmin As Word , Outmax As Word
Dim Test As Single
Dim Blinker As Word
Dim S1 As Byte                                              ' Status des PPM-Ausgangs PORTB.1
Dim Ppm_gas As Word                                         ' PPM_Gas muss zwischen 0..8192 liegen
Dim 1ms As Word
Dim Hebelbewegttemp As Word
Dim Bremstaste As Bit                                       ' BREMSTASTE IMMER AUF 0 DAMIT NIE IN BREMSZWEIG
Dim Gasmitte As Word
Dim Ppm_gaswert As Word
dim StVO_mode as bit
dim StVO_Maxthr as word

1ms = 57700                                                 ' Entspricht 65535 - 7835
'Compare1a = 0
Timer1 = 1ms                                                ' Erst mal 1 ms ausgeben (z.B. nach WD-Reset)
Compare1b = 0                                               ' Erst mal Null ausgeben (z.B. nach WD-Reset)


Channel = 0                                                 ' ADC-Kanal  (bei Rollercontrol = 0, bei Testboard = 4)
Brakebutton = 1                                             ' High durch 10k Widerstand
Bremstaste = 0                                              ' BREMSTASTE IMMER AUF 0 DAMIT NIE IN BREMSZWEIG
Timer0sekunde = 0
Timer0counter = 0

Hebelbewegttemp = 0
Hebelbewegt = 0
Pwmstep = 20                                                ' ab welcher nderung soll bedmpft werden
Incrstepthr = 2                                             ' beim Dmpfen um diesen Wert erhhen
Incrstepbrake = 250
Difflw = 0                                                  ' Diff zw. last und W
Difflwbrake = 0
Lastpwmoutthr = 0
Lastpwmoutbrake = 0
Inmin = 1023
Inmax = 0
Outmin = 0
Outmax = 1023
Scalethr = 0
Indiff = 0
Outdiff = 0
Test = 0
Flagmax = 0
Inmintemp = 0
Pwmoutthr = 0
Pwmoutbrake = 0
Blinker = 0
Postbraketmr = 50
Postthrtmr = 50
Ppm_gaswert = 0
Gasmitte = 3900                                             ' muss angepasst werden, so dass nach dem Bremsen die Bremse wieder gelst wird
                                                            ' 4175 bremst manchmal noch
                                                            ' Werte: Martin=4225, Kai=3900
Stvo_mode = 0
Stvo_maxthr = 310                                           ' 155 fr 6km/h, 310 fr 12 km/h


Enable Timer0
Enable Timer1
Enable Interrupts

' Hauptrelais einschalten
Set Relcon
Set Led_red

Waitms 500

' StVO-Taste abfragen

If In_bremstaste = 1 Then                                   ' Stvo-Mode Abfrage
   Stvo_mode = 1
end if

' Initiales Einlesen des Poti
W = Getadc(channel)
Inmin = W

'-------------------------------------------------------------------------------
'Drivemode auswaehlen
'If Drivemode = 1 Then                                       'Nur wenn Taste beim Einschalten gedrckt, gibts Speed ;)
'   'Outmax = 300
'   Sound Beeper , 2000 , 10000
'Else
'   Sound Beeper , 2000 , 10000
'   Waitms 200
'   Sound Beeper , 2000 , 10000
'End If

' Ab hier wird davon ausgegangen ,dass ein Dauemn-Gashebel mit automatischer Rckstelluung angeschlossen ist
' Mit einem Poti, das bei PowerOn z.B. auf Mitte (oder irgendwo anders ) steht, geht dieser Algorithmus in die Hose!
For Loopcount = 0 To 1000
   W = Getadc(channel)
   L = W
   Inmin = Inmin + L
   Inmin = Inmin / 2
Next Loopcount
' Mit einem Daumen-Gashebel haben wir hier den Minimumwert eingelernt

   'Toggle Led_red
Inmintemp = Inmin + 100                                     ' Ausstiegsschwelle fr "Einlernphase nach Unten"
Hebelbewegttemp = Inmin + 5
'Inmintemp = Inmintemp + Inmin

'Gas = 600                                                   ' Vorbesetzen mit einem "hohen" Wert
Do                                                          ' oberen und unteren Grenzwert lernen
   'Toggle Led_red

   For Loopcount = 0 To 500
      W = Getadc(channel)
      L = W
      Gas = Gas + L
      Gas = Gas / 2
      Call Cutoff
   Next Loopcount

   If Gas < 0 Then Gas = 0
   If Gas > Inmax Then Inmax = Gas                          ' Hchstwert einlernen

   If Inmax > 530 Then                                      ' wir haben mal einen ziemlich hohen Wert gehabt
      If Gas < 400 Then Flagmax = 1                         ' und gehen jetzt wieder deutlich unter die Hlfte
   End If

   'Toggle Blinkerled
   'Call Cutoff

Loop Until Flagmax = 1                                      ' Damit ist der Maxwert eingelernt


Do
   'Toggle Led_red
   W = Getadc(channel)
Loop Until W < Inmintemp

Waitms 500

Indiff = Inmax - Inmin
Outdiff = Outmax - Outmin                                   ' die Rechnung kann man sich sparen, da Outmin und Outmax per Programm festgelegte Werte sind

Start Watchdog


'-------------------------------------------------------------------------------
' Hauptschleife

Do

    'Toggle Led_red                                          ' Schleifenzeit messen mit Oszi, kann spter wegfallen
    For Loopcount = 0 To 1                                  ' 90
      W = Getadc(channel)
      L = W
      Gas = Gas + L
      Gas = Gas / 2                                         ' ADC liefert 10bit Werte , 0..1023
    Next Loopcount
    If Gas < 0 Then Gas = 0

'                  ( ( gas - InMin )                          )
'            Out = (------------------- x ( OutMax - OutMin ) ) + OutMin
'                  ((Inmax - Inmin )                          )


    Test = Gas - Inmin
    If Test < 0 Then Test = 0                               ' negative Werte abfangen
    Scalethr = Test / Indiff
    Scalethr = Scalethr * Outdiff
    Scalethr = Scalethr + Outmin
    Daumengas = Scalethr

    If Daumengas > Hebelbewegttemp Then                     ' wird der Hebel bettigt?
      Hebelbewegt = 1
      'Set Led_red
    Else
      Hebelbewegt = 0
      'Reset Led_red
    End If

    Difflw = Daumengas - Pwmoutthr                          ' gemessene Diff zw. Vorher und Nachher
    If Difflw < 0 Then Difflw = 0

    Difflwbrake = Daumengas - Pwmoutbrake
    If Difflwbrake < 0 Then Difflwbrake = 0

'-------------------------------------------------------------------------------
'Bremsen

    If In_bremstaste = 0 Then                               ' wenn Bremse gedrckt, setze GasAusgang auf 0

'   If Bremstaste = 1 Then
'      Toggle Led_red

      Pwmoutthr = 0                                         ' sofort Motor aus (ESC auf Null)
'      Compare1a = 0                                         'Pwmoutthr ' PWM mode ist 10 bit, also 1:1 verwenden

      'Waitms 5
'      If Daumengas > Pwmoutbrake Then
'         If Difflwbrake > Pwmstep Then
'            Pwmoutbrake = Lastpwmoutbrake + Incrstepbrake
'         End If
'      Else
'         Pwmoutbrake = Daumengas
'      End If

      Pwmoutbrake = Lastpwmoutbrake + Incrstepbrake

      If Pwmoutbrake > 1000 Then Pwmoutbrake = 1023           ' KANN zur Zerstrung der Brems-FETs fhren (?), besser weglassen?
      'If Daumengas < 40 Then Pwmoutbrake = 0

      If Postthrtmr > 0 Then
         Decr Postthrtmr                                    'Sicherheitsfeature, um den ESC abschalten zu lassen
         Pwmoutbrake = 0
      Else
'         Compare1b = Pwmoutbrake                            ' PWM mode ist 10 bit, also 1:1 verwenden
         Ppm_gas = Pwmoutbrake * 4                          ' Pwmoutthr luft von 0..1024, wir brauchen 0..~8000
         Ppm_gas = Gasmitte - Ppm_gas
         If Ppm_gas < 0 Then Ppm_gas = 0
         Ppm_gaswert = Ppm_gas
      End If

      Lastpwmoutbrake = Pwmoutbrake
      Lastpwmoutthr = 0

      Postbraketmr = 100                                    ' Totzeit nach Bremse lsen
                                                            ' legt Verzgerung des Bremse lsens fest

    Else                                                    ' Bremse NICHT gedrckt

'-------------------------------------------------------------------------------
'Beschleunigen

      Pwmoutbrake = 0                                       ' also Brems-PWM AUS
      Compare1b = 0                                         'Pwmoutbrake
      'Toggle Led_red

      If Daumengas > Pwmoutthr Then                         ' "Beschleunigen" mit Rampe
         ' nchste Zeile legt die Verzgerung fest, muss am Motor und ggf. beim Fahren ausgetestet werden
         Waitms 15

         If Difflw > Pwmstep Then
            Pwmoutthr = Lastpwmoutthr + Incrstepthr
         End If
      Else                                                  ' "Gas weg" muss in Echtzeit ablaufen
         Pwmoutthr = Daumengas
      End If

      If Pwmoutthr > 1000 Then Pwmoutthr = 1023
      If Daumengas < 40 Then Pwmoutthr = 0

      if stvo_mode = 1 then
         if Pwmoutthr > stvo_maxthr then pwmoutthr = stvo_maxthr
      end if


      If Postbraketmr > 0 Then
         Decr Postbraketmr                                  ' (alt:Sicherheitsfeature, um die BremsFETs sperren zu lassen)
         Ppm_gaswert = Gasmitte + 275                       ' Nach Bremsen kurz "Gas" geben, damit Bremse lst
      Else
'         Compare1a = Pwmoutthr                              ' PWM mode ist 10 bit, also 1:1 verwenden
'         Ppm_gas = Pwmoutthr * 8                            ' Pwmoutthr luft von 0..1024, wir brauchen 0..~8000
         Ppm_gas = Pwmoutthr * 4                            ' Pwmoutthr luft von 0..1024, wir brauchen 0..~4000
         Ppm_gas = Ppm_gas + Gasmitte
'         If Ppm_gas > 7835 Then Ppm_gas = 7835
         If Ppm_gas > 7900 Then Ppm_gas = 8100
         Ppm_gaswert = Ppm_gas
      End If

      Lastpwmoutthr = Pwmoutthr
      Lastpwmoutbrake = 0
      Postthrtmr = 1
    End If

    Reset Watchdog
    Call Cutoff

    Incr Blinker                                            ' Lebenszeichen
    If Blinker > 1000 Then
      Toggle Blinkerled
      Blinker = 0
    End If

Loop

End

'-------------------------------------------------------------------------------
'Subroutines

Sub Cutoff
   'Toggle Led_red
   If Hebelbewegt = 0 Then
     If Timer0counter > 28 Then
        Timer0counter = 0
        Incr Timer0sekunde

        Toggle Led_red
     End If
   Else
      Timer0counter = 0
      Timer0sekunde = 0
   End If

   If Timer0sekunde > 180 Then                              ' Angabe in Sekunden, Roller nach 3 Minuten ausschalten
      'relais ausschalten
      Reset Relcon
      Reset Led_red
   End If
End Sub

'-------------------------------------------------------------------------------
'Interrupts

On_timer0_overflow:
   Incr Timer0counter
   'Toggle Led_red
Return


'---Timer-----------------------------------------------------------------------
Esc_irq:

Select Case S1
   Case 0 :
      Portb.1 = 1                                           ' OCR1A   Portb.1
      S1 = 1
   Case 1 :
      Portb.1 = 0                                           ' OCR1A   Portb.1
      S1 = 0
   Case Else :
End Select

Timer1 = 1ms - Ppm_gaswert

Return
'---\Timer-----------------------------------------------------------------------